#include "ConsoleIO.h"
#include "AwesomeScrollbar.h"
#include "ScoreValidationDec.h"
#include "HiscoreOrder.h"
#include "Account.h"
#include "Textfiles.h"

#define _CRT_SECURE_NO_WARNINGS
#include <Windows.h>
#include <Shellapi.h>
#include <stdio.h>
#include <conio.h>

void PaintTAPLogo(signed short x, signed short y, char ForeColor, char BkgndColor)
{
	// I painted this in Notepad!
	ConsoleOut(x, y +  0, "XXXXXXXXX XXXXXX XXXXXXXXX XXXXXXX  XXX XXXXXXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  1, "XXXXXXXXX XXXXX  XXXXXXXXX XXX XX   XXX XXXXXXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  2, "   XXX    XXX       XXX    XXXX         XXX    ", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  3, "   XXX    XXXXX     XXX    XXXXXX   XXX   XX   ", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  4, "   XXX    XXX       XXX    XXX XXX  XXX    XX  ", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  5, "   XXX    XXX       XXX    XXX XXX  XXX     XXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  6, "   XXX    XXXXXXX   XXX    XXX  XXXX XX XXXXXXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  7, "   XXX    XXXXXXXX  XXX    XXX    XXX X XXXXXXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  8, "                                               ", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y +  9, "XXX X X XXX     XXX XXX XXX XXX X   X X XXX XXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y + 10, " X  X X X       X X X X X   X X X   X X  X  X  ", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y + 11, " X  XXX XXX     XXX XX  XXX X X X   X X  X  XXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y + 12, " X  X X X       X X X X   X X X X   X X  X  X  ", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y + 13, " X  X X XXX     X X XXX XXX XXX XXX XXX  X  XXX", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y + 14, "                                               ", -1, ForeColor, BkgndColor);
	ConsoleOut(x, y + 15, "T H E     G R A N D M A S T E R    2    P L U S", -1, ForeColor, BkgndColor);
}

void RedrawScrollbarArea(AwesomeScrollbar & sb)
{
	sb.UpdateScrollbar();

	if (sb.PaintScrollbar() == false)
	{
		PaintRect(sb.rc, 179, LOGO_FG_COLOR, BOARD_BG_COLOR);
	}
}

void PrintAccount(signed short Start, unsigned int & refuRanking, Account * pAccountAt)
{
	Start += (LIST_BOTTOM_Y - LIST_HEIGHT_Y);

	ShortRect rc(
		LIST_LEFT_X, 
		Start, 
		LIST_LEFT_X + LIST_WIDTH_X, 
		Start + 1);

	// Is this an empty line to draw?
	if (pAccountAt->wGrade == 0x7FFF)
	{
		PaintRect(rc, ' ', BOARD_FG_COLOR, BOARD_BG_COLOR);
	}
	// No, is this a header top or bottom line?
	else if (pAccountAt->wGrade == (0x7FFF - 1) || 
			 pAccountAt->wGrade == (0x7FFF - 3))
	{
		switch (pAccountAt->bMode)
		{
		case LTAP_GAMEMODE_NORMAL:
			PaintRect(rc, 196, HEAD_FG_NORMAL, HEAD_BG_COLOR);
			break;

		case LTAP_GAMEMODE_MASTER:
			PaintRect(rc, 196, HEAD_FG_MASTER, HEAD_BG_COLOR);
			break;

		case LTAP_GAMEMODE_PLUS:
			PaintRect(rc, 196, HEAD_FG_PLUS, HEAD_BG_COLOR);
			break;

		case LTAP_GAMEMODE_DEATH:
			PaintRect(rc, 196, HEAD_FG_DEATH, HEAD_BG_COLOR);
			break;
		}
	}
	// No, is this a mode header to draw?
	else if (pAccountAt->wGrade == (0x7FFF - 2))
	{
		switch (pAccountAt->bMode)
		{
		case LTAP_GAMEMODE_NORMAL:
			PaintRect(rc, ' ', HEAD_FG_NORMAL, HEAD_BG_COLOR);
			ConsoleOut(LIST_LEFT_X + ((LIST_WIDTH_X - 11) >> 1), Start, "NORMAL MODE", 11, HEAD_FG_NORMAL, HEAD_BG_COLOR);
			break;

		case LTAP_GAMEMODE_MASTER:
			PaintRect(rc, ' ', HEAD_FG_MASTER, HEAD_BG_COLOR);
			ConsoleOut(LIST_LEFT_X + ((LIST_WIDTH_X - 11) >> 1), Start, "MASTER MODE", 11, HEAD_FG_MASTER, HEAD_BG_COLOR);
			break;

		case LTAP_GAMEMODE_PLUS:
			PaintRect(rc, ' ', HEAD_FG_PLUS, HEAD_BG_COLOR);
			ConsoleOut(LIST_LEFT_X + ((LIST_WIDTH_X - 9) >> 1), Start, "PLUS MODE", 9, HEAD_FG_PLUS, HEAD_BG_COLOR);
			break;

		case LTAP_GAMEMODE_DEATH:
			PaintRect(rc, ' ', HEAD_FG_DEATH, HEAD_BG_COLOR);
			ConsoleOut(LIST_LEFT_X + ((LIST_WIDTH_X - 10) >> 1), Start, "DEATH MODE", 10, HEAD_FG_DEATH, HEAD_BG_COLOR);
			break;
		}
	}
	// No, then it is a hiscore entry
	else
	{
		char buffer[256];
		unsigned int i, j = CAPTIONS_LEFT_X;

		unsigned short wRankedLineOverride = pAccountAt->wRankedLine;

		if ((pAccountAt->bMode == LTAP_GAMEMODE_NORMAL && 
			 pAccountAt->wLevel >= 300) || 
			((pAccountAt->bMode == LTAP_GAMEMODE_PLUS || 
			  pAccountAt->bMode == LTAP_GAMEMODE_DEATH) && 
			 pAccountAt->wLevel >= 999))
		{
			wRankedLineOverride = LTAP_RANKED_GREEN;
		}

		// Clear the output line or output ranked line
		switch (wRankedLineOverride)
		{
		default:
		case LTAP_RANKED_NONE:
			PaintRect(rc, ' ', BOARD_FG_COLOR, BOARD_BG_COLOR);
			break;

		case LTAP_RANKED_GREEN:
			PaintRect(rc, 220, GREENL_COLOR, BOARD_BG_COLOR);
			break;

		case LTAP_RANKED_ORANGE:
#if NO_ORANGE
			// Paint the line with the red palette
			PaintRect(rc, 220, ORANGEL_COLOR, BOARD_BG_COLOR);
#else
			// Mix the red and yellow palette to make up an orange line, but the line takes up the 
			// whole character height as a result
			PaintRect(rc, 177, ORANGEL_COLOR, 14);
#endif
			break;
		}

		// Output ranking
		_ltoa((signed long)refuRanking, buffer, 10);
		ConsoleOut(j, Start, buffer, -1, BOARD_FG_COLOR, BOARD_BG_COLOR);
		++refuRanking;

		j += TableCaptionsWidth[INDEX_CAPTION_RANKING].NeededWidth;

		// Output name
		ConsoleOut(j, Start, pAccountAt->aName, 3, BOARD_FG_COLOR, BOARD_BG_COLOR);

		j += TableCaptionsWidth[INDEX_CAPTION_NAME].NeededWidth;
		
		for (i = 0; i < (unsigned int)sizeof (bCaptionOrder); i++)
		{
			switch (bCaptionOrder[i])
			{
			case INDEX_ORDER_GRADE:
				// Output grade
				{
					if (pAccountAt->bMode == LTAP_GAMEMODE_MASTER || 
						(pAccountAt->bMode == LTAP_GAMEMODE_DEATH && 
						 pAccountAt->wGrade >= LTAP_GRADE_M))
					{
						ConsoleOut(j, Start, (char *)capszGrades[pAccountAt->wGrade], -1, BOARD_FG_COLOR, BOARD_BG_COLOR);
					}

					j += TableCaptionsWidth[INDEX_CAPTION_GRADE + bCaptionOrder[i]].NeededWidth;
				}
				break;

			case INDEX_ORDER_TIME:
				// Output time
				{
					if (pAccountAt->bMode != LTAP_GAMEMODE_NORMAL)
					{
						unsigned long dwMinutes, dwSeconds, dwCenti;

						// This is the official TAP way of calculating time
						dwMinutes = pAccountAt->dwTime / 3600;
						dwSeconds = (pAccountAt->dwTime - (dwMinutes * 3600)) / 60;
						dwCenti = ((pAccountAt->dwTime - ((dwMinutes * 3600) + (dwSeconds * 60))) * 100) / 60;

						sprintf(buffer, "%02d:%02d:%02d", (unsigned int)dwMinutes, (unsigned int)dwSeconds, (unsigned int)dwCenti);

						ConsoleOut(j, Start, buffer, -1, BOARD_FG_COLOR, BOARD_BG_COLOR);
					}

					j += TableCaptionsWidth[INDEX_CAPTION_GRADE + bCaptionOrder[i]].NeededWidth;
				}
				break;

			case INDEX_ORDER_SCORE:
				// Output score
				{
					if (pAccountAt->bMode == LTAP_GAMEMODE_NORMAL)
					{
						sprintf(buffer, "%06d", (unsigned int)pAccountAt->dwScore);

						ConsoleOut(j, Start, buffer, -1, BOARD_FG_COLOR, BOARD_BG_COLOR);
					}

					j += TableCaptionsWidth[INDEX_CAPTION_GRADE + bCaptionOrder[i]].NeededWidth;
				}
				break;

			case INDEX_ORDER_LEVEL:
				// Output level
				{
					sprintf(buffer, "%03d", (unsigned int)pAccountAt->wLevel);

					ConsoleOut(j, Start, buffer, -1, BOARD_FG_COLOR, BOARD_BG_COLOR);

					j += TableCaptionsWidth[INDEX_CAPTION_GRADE + bCaptionOrder[i]].NeededWidth;
				}
				break;

			case INDEX_ORDER_MEDAL:
				// Output medallions
				{
					if (pAccountAt->bMode == LTAP_GAMEMODE_MASTER || 
						pAccountAt->bMode == LTAP_GAMEMODE_DEATH)
					{
						// Where to place the next medallion
						unsigned int l = j;

						static const unsigned char scabMedallionColors[] = 
						{
							0, BOARD_BG_COLOR,				// None
							BOARD_BG_COLOR, 4,				// Bronze
							BOARD_BG_COLOR, 8,				// Silver
							BOARD_BG_COLOR, 14				// Gold
						};

						for (unsigned int k = 0; k < (unsigned int)sizeof (bMedallionOrder); k++)
						{
							switch (bMedallionOrder[k])
							{
							case INDEX_ORDER_AC:
								{
									ConsoleOut(
										l, 
										Start, 
										MEDAL_AC, 
										4, 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_AC] << 1) + 0], 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_AC] << 1) + 1]);
								}
								break;

							case INDEX_ORDER_ST:
								{
									ConsoleOut(
										l, 
										Start, 
										MEDAL_ST, 
										4, 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_ST] << 1) + 0], 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_ST] << 1) + 1]);
								}
								break;

							case INDEX_ORDER_SK:
								{
									ConsoleOut(
										l, 
										Start, 
										MEDAL_SK, 
										4, 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_SK] << 1) + 0], 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_SK] << 1) + 1]);
								}
								break;

							case INDEX_ORDER_RE:
								{
									ConsoleOut(
										l, 
										Start, 
										MEDAL_RE, 
										4, 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_RE] << 1) + 0], 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_RE] << 1) + 1]);
								}
								break;

							case INDEX_ORDER_RO:
								{
									ConsoleOut(
										l, 
										Start, 
										MEDAL_RO, 
										4, 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_RO] << 1) + 0], 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_RO] << 1) + 1]);
								}
								break;

							case INDEX_ORDER_CO:
								{
									ConsoleOut(
										l, 
										Start, 
										MEDAL_CO, 
										4, 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_CO] << 1) + 0], 
										scabMedallionColors[(pAccountAt->abMedallions[INDEX_ORDER_CO] << 1) + 1]);
								}
								break;
							}

							l += 4;
						}
					}

					j += TableCaptionsWidth[INDEX_CAPTION_GRADE + bCaptionOrder[i]].NeededWidth;
				}
				break;
			}
		}

		// Output comment cropped
		if (pAccountAt->pszComment != NULL)
		{
			unsigned int uMaxLen = ((LIST_LEFT_X + LIST_WIDTH_X) - j) - 1;
			ConsoleOut(j, Start, pAccountAt->pszComment, uMaxLen, BOARD_FG_COLOR, BOARD_BG_COLOR);
		}
	}
}

// The vertical scrollbar and global state of the scrolling
AwesomeScrollbar sb(
	AwesomeScrollbar::ScrollV, 
	ShortRect(0, 0, 0, 0), 
	0, 
	0, 
	1, 
	0);

// This routine is used to find the first account in the list at position nAccountPosition. It is used by the scrolling updates 
// and the mouse double click event
Account * GetNextListAccountByPos(
				signed int nAccountPosition, 
				unsigned char * pbModeStart = NULL, 
				unsigned int * puRankingUpdate = NULL)
{
	Account * pAccountAt;

	if ((signed int)(nAccountPosition -= uNumNormalAccounts) < 0)
	{
		nAccountPosition += uNumNormalAccounts;
		pAccountAt = pAccountNormalRoot;

		if (pbModeStart != NULL)
		{
			*pbModeStart = LTAP_GAMEMODE_NORMAL;
		}
	}
	else if ((signed int)(nAccountPosition -= uNumMasterAccounts) < 0)
	{
		nAccountPosition += uNumMasterAccounts;
		pAccountAt = pAccountMasterRoot;

		if (pbModeStart != NULL)
		{
			*pbModeStart = LTAP_GAMEMODE_MASTER;
		}
	}
	else if ((signed int)(nAccountPosition -= uNumPlusAccounts) < 0)
	{
		nAccountPosition += uNumPlusAccounts;
		pAccountAt = pAccountPlusRoot;

		if (pbModeStart != NULL)
		{
			*pbModeStart = LTAP_GAMEMODE_PLUS;
		}
	}
	else if ((signed int)(nAccountPosition -= uNumDeathAccounts) < 0)
	{
		nAccountPosition += uNumDeathAccounts;
		pAccountAt = pAccountDeathRoot;

		if (pbModeStart != NULL)
		{
			*pbModeStart = LTAP_GAMEMODE_DEATH;
		}
	}
	else
	{
		return NULL;
	}

	if (puRankingUpdate != NULL)
	{
		// Doing the ranking number this way (updating it from different places) is kinda stupid and confusing, but I just want it to work
		*puRankingUpdate = 1;

		// Get the entry in the current mode list to start from (updating the ranking as well)
		while (nAccountPosition > 0)
		{
			if (pAccountAt->wGrade < (0x7FFF - 3))
			{
				++(*puRankingUpdate);
			}

			pAccountAt = pAccountAt->pNext;
			--nAccountPosition;
		}
	}
	else
	{
		// Get the entry in the current mode list to start from
		while (nAccountPosition > 0)
		{
			pAccountAt = pAccountAt->pNext;
			--nAccountPosition;
		}
	}

	return pAccountAt;
}

void NewScrollWindow(signed short NewPos)
{
	// Must scroll somewhere to redraw
	if (sb.Pos == NewPos)
	{
		return;
	}

	signed short OldPos = sb.Pos;

	// Set the page size and max scroll
	sb.Page = LIST_HEIGHT_Y;
	sb.Max = ((uNumNormalAccounts + uNumMasterAccounts + uNumPlusAccounts + uNumDeathAccounts) - 1);
	sb.Pos = NewPos;

	// Draw the right side border or a scrollbar
	RedrawScrollbarArea(sb);

	signed short AbsDistance = (sb.Pos - OldPos);

	if (AbsDistance < 0)
	{
		AbsDistance = -AbsDistance;
	}

	// Now, do we need to redraw the whole thing?
	if (NewPos < 0 || AbsDistance >= sb.Page)
	{
		NewPos = -1;
	}
	else
	{
		NewPos = 0;
	}

	signed short Start, Stop, Distance;

	// Negative new scroll means redraw the whole window from scroll 0
	if (NewPos < 0)
	{
		Start = 0;
		Stop = LIST_HEIGHT_Y;
	}
	// Else, scroll contents and redraw only the affected areas as well as set the scroll position to the new scroll position
	else
	{
		// Setup scrolling distance
		if ((Distance = OldPos - sb.Pos) == 0)
		{
			return;
		}

		ShortRect ScrollRect(
			LIST_LEFT_X, 
			LIST_BOTTOM_Y - LIST_HEIGHT_Y, 
			LIST_LEFT_X + LIST_WIDTH_X, 
			LIST_BOTTOM_Y);

		ShortRect ClipRect = ScrollRect;

		// Scroll downwards?
		if (Distance < 0)
		{
			Start = LIST_HEIGHT_Y + Distance;
			Stop = LIST_HEIGHT_Y;
		}
		// Else, scroll upwards
		else
		{
			Start = 0;
			Stop = Distance;
		}

		ScrollWindow(&ScrollRect, &ClipRect, ScrollRect.left, ScrollRect.top + Distance, ' ', BOARD_FG_COLOR, BOARD_BG_COLOR);
	}

	// Redraw only the invalid areas affected by the scrolling
	unsigned int uAccountNum = (Stop - Start);
	signed int nAccountPosition = (sb.Pos + Start);

	// Get the list to start drawing from
	unsigned char bModeStart;

	// Doing the ranking number this way (updating it from different places) is kinda stupid and confusing, but I just want it to work
	unsigned int uRanking;

	Account * pAccountAt = GetNextListAccountByPos(nAccountPosition, &bModeStart, &uRanking);

	while (pAccountAt != NULL && 
		   uAccountNum > 0)
	{
		PrintAccount(Start++, uRanking, pAccountAt);

		--uAccountNum;

		if ((pAccountAt = pAccountAt->pNext) == NULL)
		{
			if (++bModeStart > LTAP_GAMEMODE_DEATH)
			{
				break;
			}

			switch (bModeStart)
			{
			case LTAP_GAMEMODE_MASTER:
				pAccountAt = pAccountMasterRoot;
				uRanking = 1;
				break;

			case LTAP_GAMEMODE_PLUS:
				pAccountAt = pAccountPlusRoot;
				uRanking = 1;
				break;

			case LTAP_GAMEMODE_DEATH:
				pAccountAt = pAccountDeathRoot;
				uRanking = 1;
				break;
			}
		}
	}
}

int main(void)
{
	// Load order txt file. This file tells us how to order the hiscore, other than Name and Ranking that is
	LoadOrderTxt("ORDER.TXT");

	// Calculate the ranking points according to order previously loaded
	BuildRankingPriority();

	// Construct the headers for each mode in the hiscore list
	AddModeHeaders();

	// Load the score text file, and create the accounts, add points and link them. This is done now so that we can 
	// print out any invalid codes before we draw the screen. 
	// If this function is called after we set the text mode below, printf() will not be visible and parse/code errors will 
	// not be shown
	if (LoadScoreTxt("SCORE.TXT") == false)
	{
		printf("\r\nPress any key to continue...");
		_getch();
		printf("\r\n");
	}

	if (SetupMaxConsoleScreenMode() == false)
	{
		printf("Fatal error: Console text mode failed. Windows base api missing!\r\n\r\n");
		_getch();
		return 0;
	}

	SetConsoleTitleA("TAP External Hiscore List by LOst");

	//
	// We try our best to only redraw characters on screen that need to be updated
	//

	// We draw the awesome TAP logo in the center at the top
	PaintTAPLogo(LOGO_CENTER_X, LOGO_ROW_Y, LOGO_FG_COLOR, LOGO_BG_COLOR);

	// And why not put a big copyright myself underneath?
	ConsoleOut(LOGO_CENTER_X - 2, LOGO_ROW_Y + 17, "Dynamic hiscore list by LOst. Copyright   2014 LOst.");
	PaintChar(LOGO_CENTER_X + 38, LOGO_ROW_Y + 17, 184);

	// Directions how to use etc
	ConsoleOut(LIST_LEFT_X - 1, LIST_BOTTOM_Y - LIST_HEIGHT_Y - 3, "Press Up/Down or PgUp/PgDn keys to scroll the list. Press Esc key to exit.", -1, 8);

	ShortRect rc(LIST_LEFT_X, LIST_BOTTOM_Y - LIST_HEIGHT_Y, LIST_LEFT_X + LIST_WIDTH_X, LIST_BOTTOM_Y);
	ShortRect rcClient = rc;

	// Paint the client area
	PaintRect(rc, ' ', BOARD_FG_COLOR, BOARD_BG_COLOR);

	// Paint the top border
	--rc.top;
	rc.bottom = rc.top + 1;

	PaintRect(rc, 196, LOGO_FG_COLOR, BOARD_BG_COLOR);

	// Paint the bottom border
	rc.top = LIST_BOTTOM_Y;
	rc.bottom = rc.top + 1;

	PaintRect(rc, 196, LOGO_FG_COLOR, BOARD_BG_COLOR);

	// Paint the left side border
	--rc.left;
	rc.right = rc.left + 1;
	rc.bottom = rc.top;
	rc.bottom = rc.top;
	rc.top = LIST_BOTTOM_Y - LIST_HEIGHT_Y;
	
	PaintRect(rc, 179, LOGO_FG_COLOR, BOARD_BG_COLOR);

	rc.right = rc.left + LIST_WIDTH_X + 1;

	// Paint the 4 border corners
	PaintChar(rc.left, rc.top - 1, 218, LOGO_FG_COLOR, BOARD_BG_COLOR);
	PaintChar(rc.left, rc.bottom, 192, LOGO_FG_COLOR, BOARD_BG_COLOR);
	PaintChar(rc.right, rc.top - 1, 191, LOGO_FG_COLOR, BOARD_BG_COLOR);
	PaintChar(rc.right, rc.bottom, 217, LOGO_FG_COLOR, BOARD_BG_COLOR);

	// Adjust the rectangle to be the update area of the scrollbar
	rc.left = rc.right;
	rc.right = rc.left + 1;

	sb.rc = rc;

	// Draw captions
	unsigned int i, j;

	j = CAPTIONS_LEFT_X;

	ConsoleOut(j, rcClient.top - 1, TableCaptionsWidth[INDEX_CAPTION_RANKING].szCaption, -1, LOGO_FG_COLOR, BOARD_BG_COLOR);

	j += TableCaptionsWidth[INDEX_CAPTION_RANKING].NeededWidth;

	ConsoleOut(j, rcClient.top - 1, TableCaptionsWidth[INDEX_CAPTION_NAME].szCaption, -1, LOGO_FG_COLOR, BOARD_BG_COLOR);

	j += TableCaptionsWidth[INDEX_CAPTION_NAME].NeededWidth;

	for (i = 0; i < (unsigned int)sizeof (bCaptionOrder); i++)
	{
		ConsoleOut(j, rcClient.top - 1, TableCaptionsWidth[INDEX_CAPTION_GRADE + bCaptionOrder[i]].szCaption, -1, LOGO_FG_COLOR, BOARD_BG_COLOR);

		j += TableCaptionsWidth[INDEX_CAPTION_GRADE + bCaptionOrder[i]].NeededWidth;
	}

	ConsoleOut(j, rcClient.top - 1, TableCaptionsWidth[INDEX_CAPTION_COMMENT].szCaption, -1, LOGO_FG_COLOR, BOARD_BG_COLOR);

	// Scroll with a negative value to redraw the whole visible list
	NewScrollWindow(-1);

	//
	// Time to do input events
	//
	
	unsigned long dwPreviousButtonState = 0;
	unsigned long dwMouseCaptured = 0;
	signed short ElevatorGrip = 0;
	signed short CapturedOldPos = 0;
	DWORD dwRead, dwIndex;
	INPUT_RECORD IR[128];

	HANDLE hStdIn = GetStdHandle(STD_INPUT_HANDLE);

	if (hStdIn == INVALID_HANDLE_VALUE)
	{
		_getch();

		CleanupAccounts();

		RevertToDefaultScreenMode();

		return 0;
	}

	bool FRun = true;

	while (FRun == true)
	{
		// Wait for console input events
		ReadConsoleInput(
			hStdIn, 
			IR, 
			128, 
			&dwRead);

		for (dwIndex = 0; dwIndex < dwRead; dwIndex++)
		{
			switch (IR[dwIndex].EventType)
			{
			case KEY_EVENT:
				if (!(dwMouseCaptured & 1))
				{
					if (IR[dwIndex].Event.KeyEvent.bKeyDown == 0x1)
					{
						switch (IR[dwIndex].Event.KeyEvent.wVirtualKeyCode)
						{
						case VK_ESCAPE:
							FRun = false;
							break;

						case VK_UP:
							if ((sb.Pos - 1) < 0)
							{
								NewScrollWindow(0);
							}
							else
							{
								NewScrollWindow(sb.Pos - 1);
							}
							break;

						case VK_DOWN:
							NewScrollWindow(sb.Pos + 1);
							break;

						case VK_PRIOR:
							if ((sb.Pos - (sb.Page - 1)) < 0)
							{
								NewScrollWindow(0);
							}
							else
							{
								NewScrollWindow(sb.Pos - (sb.Page - 1));
							}
							break;

						case VK_NEXT:
							NewScrollWindow(sb.Pos + (sb.Page - 1));
							break;

						case VK_HOME:
							if (sb.Pos != 0)
							{
								NewScrollWindow(0);
							}
							break;

						case VK_END:
							if (sb.Pos < (sb.Max - (sb.Page - 1)))
							{
								NewScrollWindow(sb.Max - (sb.Page - 1));
							}
							break;
						}
					}
				}
				break;

			case MOUSE_EVENT:
				{
					if (IR[dwIndex].Event.MouseEvent.dwEventFlags & DOUBLE_CLICK)
					{
						if ((unsigned short)(IR[dwIndex].Event.MouseEvent.dwMousePosition.X - LIST_LEFT_X) < (unsigned short)LIST_WIDTH_X)
						{
							unsigned short ListPos = (unsigned short)(IR[dwIndex].Event.MouseEvent.dwMousePosition.Y - (LIST_BOTTOM_Y - LIST_HEIGHT_Y));

							if (ListPos < (unsigned short)LIST_HEIGHT_Y)
							{
								Account * pAccountAt = GetNextListAccountByPos(ListPos + sb.Pos, NULL, NULL);

								if (pAccountAt != NULL && 
									pAccountAt->pszComment != NULL)
								{
									// Find either of these substrings to search for web addresses in the comment
									const char cszHttp[] = "http";
									const char cszWww[] = "www.";
									
									char * pSubstrChk = strstr(pAccountAt->pszComment, cszHttp);

									if (pSubstrChk == NULL)
									{
										pSubstrChk = strstr(pAccountAt->pszComment, cszWww);
									}

									if (pSubstrChk != NULL)
									{
										// Find the first whitespace, tab or NULL-terminator to get the length of the string
										i = 0;

										while (pSubstrChk[i] != ' ' && 
											   pSubstrChk[i] != '\t' && 
											   pSubstrChk[i] != '\0')
										{
											++i;
										}

										// Allocate the string temporarly
										char * pszUrl = (char *)malloc(i + 1);
										
										if (pszUrl != NULL)
										{
											pszUrl[i] = '\0';

											strncpy(pszUrl, pSubstrChk, i);

											ShellExecuteA(NULL, "open", pszUrl, NULL, NULL, SW_SHOWNORMAL);

											free(pszUrl);
										}
									}
								}
							}
						}
						break;
					}

					// Did we click the left button once?
					if (!(dwPreviousButtonState & FROM_LEFT_1ST_BUTTON_PRESSED) && 
						(IR[dwIndex].Event.MouseEvent.dwButtonState & FROM_LEFT_1ST_BUTTON_PRESSED))
					{
						// Do the action if we are within the scrollbar areas
						switch (sb.ScrollHitTest(IR[dwIndex].Event.MouseEvent.dwMousePosition.X, IR[dwIndex].Event.MouseEvent.dwMousePosition.Y))
						{
						case AwesomeScrollbar::ScrollHTArrowLo:
							if ((sb.Pos - 1) < 0)
							{
								NewScrollWindow(0);
							}
							else
							{
								NewScrollWindow(sb.Pos - 1);
							}
							break;

						case AwesomeScrollbar::ScrollHTArrowHi:
							NewScrollWindow(sb.Pos + 1);
							break;

						case AwesomeScrollbar::ScrollHTTrackLo:
							if ((sb.Pos - (sb.Page - 1)) < 0)
							{
								NewScrollWindow(0);
							}
							else
							{
								NewScrollWindow(sb.Pos - (sb.Page - 1));
							}
							break;

						case AwesomeScrollbar::ScrollHTTrackHi:
							NewScrollWindow(sb.Pos + (sb.Page - 1));
							break;

						case AwesomeScrollbar::AcrollHTElevator:
							{
								dwMouseCaptured |= 1;

								CapturedOldPos = IR[dwIndex].Event.MouseEvent.dwMousePosition.Y;

								ElevatorGrip = sb.GetElevatorGrip(CapturedOldPos);
							}
							break;
						}

						dwPreviousButtonState = IR[dwIndex].Event.MouseEvent.dwButtonState;
					}
					// No we released the left button
					else if (!(IR[dwIndex].Event.MouseEvent.dwButtonState & dwPreviousButtonState) && 
							 (dwPreviousButtonState & FROM_LEFT_1ST_BUTTON_PRESSED))
					{
						// Should we release the capture?
						if (dwMouseCaptured & 0x1)
						{
							dwMouseCaptured &= ~0x1;

							if (CapturedOldPos != IR[dwIndex].Event.MouseEvent.dwMousePosition.Y)
							{
								// Scroll to new position test
								if (sb.TrackElevator(IR[dwIndex].Event.MouseEvent.dwMousePosition.Y - ElevatorGrip) == true)
								{
									NewScrollWindow(sb.TrackPos);
								}
							}
						}

						dwPreviousButtonState = IR[dwIndex].Event.MouseEvent.dwButtonState;
					}
					else
					{
						// Are we tracking the elevator?
						if (dwMouseCaptured & 0x1)
						{
							if (CapturedOldPos != IR[dwIndex].Event.MouseEvent.dwMousePosition.Y)
							{
								CapturedOldPos = -1;

								// Scroll to new position test
								if (sb.TrackElevator(IR[dwIndex].Event.MouseEvent.dwMousePosition.Y - ElevatorGrip) == true)
								{
									NewScrollWindow(sb.TrackPos);
								}
							}
						}
					}
				}
				break;
			}
		}
	}

	CleanupAccounts();

	RevertToDefaultScreenMode();

	return 0;
}
