/************************************************
                      LTAP

           Score Validation Computation
                     by LOst

 Copyright (C) 2008 - 2014 LOst. 

 Attention:
   This code is NOT the "full version". 
   The encode function has been removed. If you 
   wish to use both the encode and decode 
   functions within your own code, please 
   contact me by PM.
   It's allowed to release this source to any of 
   many TGM clone developers to help expand the 
   TGM universe. 
   If you use, please give credits to me: LOst.
*************************************************/

#ifndef SCORE_VALIDATION_DEC_H
#define SCORE_VALIDATION_DEC_H

#ifdef __cplusplus
extern "C" 
{
#endif

//////////////////////////////////////////////////
#define TIME_TO_FRAMES(m, s, f)				(m * 3600UL + s * 60UL + f)
//////////////////////////////////////////////////
#define LTAP_GAMEFLAG_NORMAL				0x0001
#define LTAP_GAMEFLAG_MASTER				0x0002
#define LTAP_GAMEFLAG_DOUBLES				0x0004
#define LTAP_GAMEFLAG_VS					0x0008
#define LTAP_GAMEFLAG_INVISIBLE				0x0010
#define LTAP_GAMEFLAG_20G					0x0020
#define LTAP_GAMEFLAG_BIG					0x0040
#define LTAP_GAMEFLAG_PLUS					0x0080
#define LTAP_GAMEFLAG_CEMENT				0x0100
#define LTAP_GAMEFLAG_ITEM					0x0200
#define LTAP_GAMEFLAG_TLS					0x0400
#define LTAP_GAMEFLAG_NOITEM				0x0800
#define LTAP_GAMEFLAG_DEATH					0x1000
#define LTAP_GAMEFLAG_TIMEOUT				0x2000
//////////////////////////////////////////////////
#define LTAP_RANKED_NONE					0
#define LTAP_RANKED_GREEN					1
#define LTAP_RANKED_ORANGE					2
//////////////////////////////////////////////////
#define LTAP_GAMEMODE_NORMAL				0
#define LTAP_GAMEMODE_MASTER				1
#define LTAP_GAMEMODE_PLUS					2
#define LTAP_GAMEMODE_DEATH					3
//////////////////////////////////////////////////
#define LTAP_GRADE_9						0
#define LTAP_GRADE_8						1
#define LTAP_GRADE_7						2
#define LTAP_GRADE_6						3
#define LTAP_GRADE_5						4
#define LTAP_GRADE_4						5
#define LTAP_GRADE_3						6
#define LTAP_GRADE_2						7
#define LTAP_GRADE_1						8
#define LTAP_GRADE_S1						9
#define LTAP_GRADE_S2						10
#define LTAP_GRADE_S3						11
#define LTAP_GRADE_S4						12
#define LTAP_GRADE_S5						13
#define LTAP_GRADE_S6						14
#define LTAP_GRADE_S7						15
#define LTAP_GRADE_S8						16
#define LTAP_GRADE_S9						17
#define LTAP_GRADE_M						18
#define LTAP_GRADE_GM						19
//////////////////////////////////////////////////
#define LTAP_MEDALLION_NONE					0
#define LTAP_MEDALLION_BRONZE				1
#define LTAP_MEDALLION_SILVER				2
#define LTAP_MEDALLION_GOLD					3
//////////////////////////////////////////////////
extern const char caValidationLetters[20];
//////////////////////////////////////////////////
extern const char caHiscoreNameLetters[43];
//////////////////////////////////////////////////
extern const char caScramble[256];
//////////////////////////////////////////////////
extern const char * capszGrades[20];
//////////////////////////////////////////////////
extern const char * capszMedallions[4];
//////////////////////////////////////////////////

int DecodeTAPScoreValidation(
		char * pstrNameABC,							// "KAN\0" or "CT \0"
		char * pstrScoreValidation,					// 16 character validation code to decode
		unsigned char * pbGameMode,					// [Optional pointer to store] LTAP_GAMEMODE_NORMAL or LTAP_GAMEMODE_MASTER
		unsigned short * pwVisibleGrade,			// [Optional pointer to store] LTAP_GRADE_M
		unsigned short * pwLevel,					// [Optional pointer to store] Max 300 for Normal mode or max 999 for other modes
		unsigned short * pwRankedLine,				// [Optional pointer to store] LTAP_RANKED_NONE
		unsigned long * pdwMasteringTime,			// [Optional pointer to store] TIME_TO_FRAMES(18, 31, 59) in all modes except Normal Mode
		unsigned long * pdwNormalModeScore,			// [Optional pointer to store] Score in Normal Mode only
		unsigned char * pbMedallionAllClear,		// [Optional pointer to store] LTAP_MEDALLION_NONE
		unsigned char * pbMedallionSectionTime, 	// [Optional pointer to store] LTAP_MEDALLION_NONE
		unsigned char * pbMedallionSkill, 			// [Optional pointer to store] LTAP_MEDALLION_NONE
		unsigned char * pbMedallionRecovery, 		// [Optional pointer to store] LTAP_MEDALLION_NONE
		unsigned char * pbMedallionRotation, 		// [Optional pointer to store] LTAP_MEDALLION_NONE
		unsigned char * pbMedallionCombo); 			// [Optional pointer to store] LTAP_MEDALLION_NONE

#ifdef __cplusplus
}
#endif

#endif
